{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Homework 6\n",
    "\n",
    "## Due Tuesday, November 23th, 2021 at 11:59 PM.\n",
    "\n",
    "### Be sure to push the final version of your code to your GitHub repo.  Follow the instructions on the course website.\n",
    "\n",
    "### Topics\n",
    "#### [Problem 0](#p0).  Homework Workflow [10 pts]\n",
    "- Prerequisite\n",
    "\n",
    "####  [Problem 1](#part_1):  BST Extensions [30 pts]\n",
    "- [Part A](#p1.a). Remove minimum node (`_removemin`)\n",
    "- [Part B](#p1.b). Remove node (`_remove`)\n",
    "- [Part C](#p1.c). BST Traversal\n",
    "\n",
    "####  [Problem 2](#part_2):  Heaps [30 pts]\n",
    "- [Part A](#p2.a). Build a heap\n",
    "- [Part B](#p2.b). Modify a heap\n",
    "- [Part C](#p2.c). Min- and max- heap\n",
    "\n",
    "####  [Problem 3](#part_3):  Priority Queue [30 pts]\n",
    "- [Part A](#p3.a). Naive priority queue\n",
    "- [Part B](#p3.b). Priority queue based on min-heap\n",
    "- [Part C](#p3.c). Compare two implementations of a priority queue\n",
    "\n",
    "---"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**Note: We will be using autograders for the problems below so make sure you conform with the interfaces as described in the question statement. DO NOT change any of the given code (i.e. class names, methods names, etc.). However, you are free to implement any helper methods as needed.**\n",
    "\n",
    "**Note:** This homework may look very lengthy, but this is because we provide substantial code to you to help you start the problems.\n",
    "\n",
    "**Note:** Please make sure to keep all your necessary imports in your deliverables files; we will add/remove imports on our end as we see fit.\n",
    "\n",
    "**Note:** Demos for your classes are not necessary for this homework."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p0'></a>\n",
    "## Problem 0: Homework Workflow\n",
    "Once you receive HW5 feedback, you will need to merge your `HW5-dev` branch into `master`. \n",
    "\n",
    "You will earn points for following all stages of the git workflow which involves:\n",
    "* 3pts for merging `HW5-dev` into `master`\n",
    "* 5pts for completing HW6 on `HW6-dev`\n",
    "* 2pts for making a PR on `HW6-dev` to merge into `master`\n",
    "![Sample Github Submission](../fig/HW6_submission.png)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='part_1'></a>\n",
    "# Problem 1 [30 pts]:  BST Extensions\n",
    "\n",
    "This problem builds on Problem 2 of Homework 5 in which you wrote a binary search tree. This time, you will first write some more supporting functions for your BST and then write a class to perform traversals on it.\n",
    "\n",
    "**Put the following code and your edits for this problem in a file titled `P1.py`. Failure to follow this instruction will result in point deduction.**\n",
    "\n",
    "```python\n",
    "class BSTNode:\n",
    "\n",
    "    def __init__(self, key, val):\n",
    "        self.key, self.val = key, val\n",
    "        self.left, self.right = None, None\n",
    "        self.size = 1\n",
    "    \n",
    "    def __str__(self):\n",
    "        return f'BSTNode({self.key}, {self.val})' + \\\n",
    "               '\\n|\\n|-(L)->' + '\\n|      '.join(str(self.left ).split('\\n')) + \\\n",
    "               '\\n|\\n|-(R)->' + '\\n|      '.join(str(self.right).split('\\n'))\n",
    "        \n",
    "        \n",
    "class BSTTable:\n",
    "    def __init__(self):\n",
    "        self._root = None\n",
    "    \n",
    "    def __str__(self):\n",
    "        return str(self._root)\n",
    "    \n",
    "    def __len__(self):\n",
    "        return self._size(self._root)\n",
    "        \n",
    "    def put(self, key, val):\n",
    "        self._root = self._put(self._root, key, val)\n",
    "    \n",
    "    def get(self, key):\n",
    "        return self._get(self._root, key)\n",
    "    \n",
    "    def _put(self, node, key, val):\n",
    "        if not node: \n",
    "            return BSTNode(key, val)\n",
    "        if   key < node.key:\n",
    "            node.left  = self._put(node.left,  key, val)\n",
    "        elif key > node.key:\n",
    "            node.right = self._put(node.right, key, val)\n",
    "        else:\n",
    "            node.val = val\n",
    "        node.size = 1 + self._size(node.left) + self._size(node.right)\n",
    "        return node\n",
    "    \n",
    "    def _get(self, node, key):\n",
    "        if not node:\n",
    "            raise KeyError(f'key not found: {key}')\n",
    "        if   key < node.key:\n",
    "            return self._get(node.left,  key)\n",
    "        elif key > node.key:\n",
    "            return self._get(node.right, key)\n",
    "        else:\n",
    "            return node.val\n",
    "    \n",
    "    @staticmethod\n",
    "    def _size(node):\n",
    "        return node.size if node else 0\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p1.a'></a>\n",
    "### Part A [10 pts]: Remove minimum node (`_removemin`)\n",
    "\n",
    "**Your task:** Please implement the method `_removemin` in your `BSTTable` class. It takes a `node` as an argument. It will return the subtree with the smallest node (the node with the smallest key) removed.\n",
    "\n",
    "In [Part B](#p1.B) of this problem, you will see that the `_removemin` function will help us reduce the complexity of a related function called `_remove`.\n",
    "\n",
    "**Hint:** Remember to update the `size` of the nodes.\n",
    "\n",
    "**Hint:** Remember that the `_removemin` function should modify the tree.\n",
    "\n",
    "**Hint:** check out these [slides](https://algs4.cs.princeton.edu/lectures/keynote/32BinarySearchTrees-2x2.pdf), especially the BST node removal\n",
    "\n",
    "### Demo\n",
    "```python\n",
    "tree = BSTTable()\n",
    "tree.put(0, 'd')\n",
    "tree.put(2, 'c')\n",
    "tree.put(5, 'a')\n",
    "tree.put(1, 'b')\n",
    "print(tree._root)\n",
    "\n",
    "BSTNode(0, d)\n",
    "|\n",
    "|-(L)->None\n",
    "|\n",
    "|-(R)->BSTNode(2, c)\n",
    "|      |\n",
    "|      |-(L)->BSTNode(1, b)\n",
    "|      |      |\n",
    "|      |      |-(L)->None\n",
    "|      |      |\n",
    "|      |      |-(R)->None\n",
    "|      |\n",
    "|      |-(R)->BSTNode(5, a)\n",
    "|      |      |\n",
    "|      |      |-(L)->None\n",
    "|      |      |\n",
    "|      |      |-(R)->None\n",
    "\n",
    "print(t._removemin(t._root))\n",
    "\n",
    "BSTNode(2, c)\n",
    "|\n",
    "|-(L)->BSTNode(1, b)\n",
    "|      |\n",
    "|      |-(L)->None\n",
    "|      |\n",
    "|      |-(R)->None\n",
    "|\n",
    "|-(R)->BSTNode(5, a)\n",
    "|      |\n",
    "|      |-(L)->None\n",
    "|      |\n",
    "|      |-(R)->None\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p1.b'></a>\n",
    "### Part B [10 pts]: Remove Node\n",
    "The `remove` method removes the node with the corresponding key. It delegates the function calls to `_remove`, which takes a `node` and a `key` as an argument and returns the subtree **without** the node whose key is `key`.\n",
    "\n",
    "**Your task**: Add and implement the following to the `BSTTable` class:\n",
    "```python\n",
    "def remove(self, key):\n",
    "    self._root = self._remove(self._root, key)\n",
    "\n",
    "def _remove(self, node, key)\n",
    "    # TODO: Should return a subtree whose root is <node> but without\n",
    "    #       the node whose key is <key>\n",
    "    pass\n",
    "```\n",
    "**The method should raise a `KeyError` if no node whose key is `key` is found.**\n",
    "\n",
    "**Hints:**\n",
    "- As in `_removemin`, remember to update the `size` of the nodes.\n",
    "- Remember that after the removal of a node, the returned subtree should still be a binary search tree.\n",
    "- Your `_remove` should be recursive. Think about which situations you should be able to handle.\n",
    "  - What if the current node's key is greater/smaller than the key we want to remove?\n",
    "  - What if we reach the node we are looking for? How do you make sure the subtree you return is still a binary tree?\n",
    "  - How can you use `_removemin` to make your life a little easier? **Note**: you aren't required to use `_removemin` here but it can reduce the amount of code duplication\n",
    "- you are free to define inner or helper functions along with the class skeleton above"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Demo\n",
    "```python\n",
    "tree = BSTTable()\n",
    "tree.put(5, 'a')\n",
    "tree.put(1, 'b')\n",
    "tree.put(2, 'c')\n",
    "tree.put(0, 'd')\n",
    "```\n",
    "\n",
    "```python\n",
    "tree.remove(5)\n",
    "print(tree)\n",
    "\n",
    "BSTNode(1, b)\n",
    "|\n",
    "|-(L)->BSTNode(0, d)\n",
    "|      |\n",
    "|      |-(L)->None\n",
    "|      |\n",
    "|      |-(R)->None\n",
    "|\n",
    "|-(R)->BSTNode(2, c)\n",
    "|      |\n",
    "|      |-(L)->None\n",
    "|      |\n",
    "|      |-(R)->None\n",
    "\n",
    "\n",
    "tree.remove(1)\n",
    "print(tree)\n",
    "\n",
    "BSTNode(2, c)\n",
    "|\n",
    "|-(L)->BSTNode(0, d)\n",
    "|      |\n",
    "|      |-(L)->None\n",
    "|      |\n",
    "|      |-(R)->None\n",
    "|\n",
    "|-(R)->None\n",
    "```\n",
    "\n",
    "**What should this return?**\n",
    "```python\n",
    "t.remove(10)\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p1.c'></a>\n",
    "### Part C [10 pts]: BST Traversal\n",
    "During lectures we discussed three types of depth-first traversal (DFS): preorder, inorder, and postorder.  In addition to the lecture notes, here is another reference: [Tree Traversal](https://en.wikipedia.org/wiki/Tree_traversal#Depth-first_search).\n",
    "\n",
    "**Your task**: Write an iterator class called `DFSTraversal` that allows us to traverse a BST according to a user-specified order.\n",
    "\n",
    "The `DFSTraversal` class should meet the following specifications:\n",
    "\n",
    "* The constructor takes a `BSTTable` object called `tree` and one of the enums from `DFSTraversalTypes` (see skeleton below). \n",
    "    * **Note:** You should be using the enums and not regular integers `1`, `2`, or `3`.\n",
    "* `__iter__(self)`: This is the initialization of an iterator\n",
    "* `__next__(self)`: This is called in the iterator for getting the next `BSTNode` in the tree. **This dunder method should raise a `StopIteration` error when the entire BST has been traversed.**\n",
    "* `inorder`, `preorder`, `postorder`: these will perform the actual traversal\n",
    "\n",
    "**Hint:** `inorder`, `preorder`, `postorder` should not return anything; they perform a traversal of your tree. To figure out the action they perform look at the demo below\n",
    "\n",
    "### Demo of  `DFSTraversal`\n",
    "A use case of the `DFSTraversal` class:\n",
    "\n",
    "```python\n",
    "input_array = [(4, 'a'), (9, 'c'), (2, 'f'), (3, 'z'), (11, 'i'), (8, 'r')]\n",
    "bst = BSTTable()\n",
    "for key, val in input_array:\n",
    "    bst.put(key, val)\n",
    "traversal = DFSTraversal(bst, DFSTraversalTypes.INORDER)\n",
    "for node in traversal:\n",
    "    print(str(node.key) + ', ' + node.val)\n",
    "```\n",
    "The above should print:\n",
    "```\n",
    "2, f\n",
    "3, z\n",
    "4, a\n",
    "8, r\n",
    "9, c\n",
    "11, i\n",
    "```\n",
    "\n",
    "**Note:**\n",
    "It is perfectly fine to have an instance such as `traversal` above that is only able to iterate through the elements one time (you do *not* need to worry about resetting so that it can iterate through multiple times)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "collapsed": true
   },
   "source": [
    "Use the class skeleton below for your traversal implementation (you are free to define inner or helper functions along with this skeleton)\n",
    "\n",
    "**Note: Put your `DFSTraversal` class in the same file as the previous problems (`P1.py`)**\n",
    "\n",
    "```python\n",
    "from enum import Enum\n",
    "\n",
    "class DFSTraversalTypes(Enum):\n",
    "    PREORDER = 1\n",
    "    INORDER = 2\n",
    "    POSTORDER = 3\n",
    "\n",
    "class DFSTraversal():\n",
    "    def __init__(self, tree: BSTTable, traversalType: DFSTraversalTypes):\n",
    "        # TODO: implement\n",
    "        pass\n",
    "        \n",
    "    def __iter__(self):\n",
    "        # TODO: implement\n",
    "        pass\n",
    "     \n",
    "    def __next__(self):\n",
    "        # TODO: implement\n",
    "        pass\n",
    "\n",
    "    def inorder(self, bst: BSTTable):\n",
    "        # TODO: implement\n",
    "        return\n",
    "\n",
    "    def preorder(self, bst: BSTTable):\n",
    "        # TODO: implement\n",
    "        return\n",
    "    \n",
    "    def postorder(self, bst: BSTTable):\n",
    "        # TODO: implement\n",
    "        return\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Deliverables\n",
    "- `P1.py`: should contain implementations for `BSTTable`, `BSTNode` and `DFSTraversal` classes. `BSTTable` should now have `_removemin` and `_remove` methods."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='part_2'></a>\n",
    "# Problem 2 [30 pts]: Heaps"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "This question is all about the binary heap data structure. A (binary) heap is a (nearly) complete binary tree; this means all of it's non-leaf nodes have exactly two children which make it suitable to store in a compact and memory efficient array. Each node of the tree is an element in the array.\n",
    "\n",
    "The two types of binary heaps are: *min-heap* and *max-heap*. The **heap-property** is the most important invariant that holds at every node in the tree and is dependent on the type of heap we consider. In a *min-heap* the heap-property states:\n",
    "- In an array-backed min-heap, $A$, the following relation holds for every node (other than the root), $A[i]$: $A[Parent(i)] \\leq A[i]$\n",
    "- the root is the minimum element of the tree\n",
    "\n",
    "For a *max-heap*, the above comparison between parent ($A[Parent(i)]$) and child node ($A[i]$) is reversed and the root represents the tree's maximum element.\n",
    "\n",
    "**Your objective** by the end of the question is to implement a binary max- and min-heap that support the following operations:\n",
    "- `heapify`: maintains the max/min-heap property\n",
    "- `build_heap`: turns an unordered array into a valid max/min-heap\n",
    "- `heappush`: inserts an element into the heap\n",
    "- `heappop`: removes and returns the heap's minimum/maximum element\n",
    "\n",
    "**Hint:** Play around with this [Heap visualization](https://www.cs.usfca.edu/~galles/visualization/Heap.html) tool to get an intuition of its inner workings.\n",
    "\n",
    "**Hint:** For an overview of operations on Heaps see these [Heap lectures](http://www.mathcs.emory.edu/~cheung/Courses/171/Syllabus/9-BinTree/).\n",
    "\n",
    "**Hint:** See the [Wikipedia Binary Heap Page](https://en.wikipedia.org/wiki/Binary_heap#Heap_operations) for useful guidance on potential solutions.\n",
    "\n",
    "**Hint:** your `build_heap` output does not have to be consistent with our demo printouts since [heap element arrangements are not unique](https://stackoverflow.com/questions/30552777/when-building-heap-is-heap-unique). Your heap should simply support the heap-property at every node but can yield a number of different permutations of elements at every level (which on an interesting side-note can be computed using [Heap's Algorithm](https://academic.oup.com/comjnl/article/6/3/293/360213) named after B. R. Heap)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p2.A'></a>\n",
    "## Part A [10 pts] : Building a min-heap\n",
    "**Your task**: implement the `heapify` and `build_heap` functions for a **min-heap.**\n",
    "\n",
    "**Hint:** By the end of the problem, we want you to have both a min- and max-heap. To avoid code duplication, notice that the only function dependent on the heap-type are the ones that need to preserve the heap-property (i.e., whenever we *compare* parent and child node). You will be reminded of this later on in the problem.\n",
    "\n",
    "Copy the following `Heap` skeleton into a file called **P2.py** and complete the implementation:\n",
    "\n",
    "```python\n",
    "from math import floor\n",
    "from typing import List\n",
    "\n",
    "class Heap:\n",
    "    def __init__(self, array: List[int]) -> None:\n",
    "        self.elements = array\n",
    "        self.size = len(array) # Number of elements in heap\n",
    "        self.build_heap()\n",
    "\n",
    "    # index of left child of the node at idx\n",
    "    def left(self, idx: int) -> int:\n",
    "        return 2 * idx + 1\n",
    "\n",
    "    # index of right child of the node at idx\n",
    "    def right(self, idx: int) -> int:\n",
    "        return 2 * idx + 2\n",
    "\n",
    "    def parent(self, idx: int) -> int:\n",
    "        return floor((idx - 1) / 2)\n",
    "\n",
    "    def swap(self, idx1: int, idx2: int) -> None:\n",
    "        tmp = self.elements[idx1]\n",
    "        self.elements[idx1] = self.elements[idx2]\n",
    "        self.elements[idx2] = tmp\n",
    "        \n",
    "    def to_string(self, prefix: str = \"\", idx: int = 0, left: bool = False) -> str:\n",
    "        if self.size == 0:\n",
    "            return '\\\\--'\n",
    "        elif idx < self.size:\n",
    "            buf = prefix\n",
    "            if left:\n",
    "                buf = buf + \"|-- \"\n",
    "            else:\n",
    "                buf = buf + \"\\\\-- \"\n",
    "            buf = buf + '\\033[1m' + str(self.elements[idx]) + '\\033[0m' + '\\n'\n",
    "            #buf = buf + str(self.elements[idx]) + '\\n' #use if above doesn't work\n",
    "            \n",
    "            new_prefix = prefix\n",
    "            if left:\n",
    "                new_prefix = new_prefix + \"|   \"\n",
    "            else:\n",
    "                new_prefix = new_prefix + \"    \"\n",
    "\n",
    "            return buf + \\\n",
    "                    self.to_string(new_prefix, self.left(idx), True) + \\\n",
    "                    self.to_string(new_prefix, self.right(idx), False)\n",
    "        else:\n",
    "            return ''\n",
    "\n",
    "    def __str__(self) -> str:\n",
    "        return self.to_string()\n",
    "\n",
    "    def __len__(self) -> int:\n",
    "        return self.size\n",
    "\n",
    "    def heapify(self, idx: int) -> None:\n",
    "        # TODO: implement\n",
    "        pass\n",
    "\n",
    "    def build_heap(self) -> None:\n",
    "        # TODO: implement\n",
    "        pass\n",
    "```\n",
    "\n",
    "### Demo of building a heap\n",
    "```python\n",
    "h = Heap([-1,0,0,15,23,1,2,3]) # The heap tree will be built during initialization\n",
    "print(h)\n",
    "```\n",
    "This should output a valid permutation of the following graph:\n",
    "```\n",
    "\\-- -1\n",
    "    |-- 0\n",
    "    |   |-- 3\n",
    "    |   |   |-- 15\n",
    "    |   \\-- 23\n",
    "    \\-- 0\n",
    "        |-- 1\n",
    "        \\-- 2\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p2.B'></a>\n",
    "## Part B [10 pts]: Modifying a heap\n",
    "Now that you can build a min-heap, we want to add some more useful functionality to it such as inserting and removing elements.\n",
    "\n",
    "**Your task**: implement the methods `heappush` and `heappop` for your `Heap` class.\n",
    "\n",
    "- `heappush`: inserts a new element into the heap (while maintaining its heap-property!)\n",
    "- `heappop`:\n",
    "  - this function should remove the heap's minimum element and return this minimum element to the caller\n",
    "  - **Raise an `IndexError` when trying to pop from an empty heap**\n",
    "      - Here is a quick review of how to raise an IndexError:\n",
    "        ```python\n",
    "        arr = [0,1,2]\n",
    "        get_fourth_element = 3\n",
    "        if get_fourth_element > len(arr) - 1:\n",
    "            raise IndexError('Cannot get fourth element in array since it does not exist.')\n",
    "        ```\n",
    "\n",
    "Add the following methods to your `Heap` class from [Part A](#p2.A) and finish their implementation:\n",
    "```python\n",
    "def heappush(self, key: int) -> None:\n",
    "    # TODO: implement\n",
    "    pass\n",
    "\n",
    "def heappop(self) -> int:\n",
    "    # TODO: implement\n",
    "    pass\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p2.C'></a>\n",
    "## Part C [10 pts]: A Wild Max-Heap Appears\n",
    "As hinted in [Part A](#p2.A) of this question most of the logic for building and modifying a binary heap is the same between min-heaps and max-heaps. The main difference between the two is the heap-property that has to hold for all nodes.\n",
    "\n",
    "**Your task**: Rewrite your `Heap` class from [Part A](#p2.A) and [Part B](#p2.B) and create two classes, `MinHeap` and `MaxHeap`, according to the code skeleton below.\n",
    "\n",
    "#### Notes\n",
    "* `MinHeap` and `MaxHeap` should be subclasses that implement the `compare()` method.\n",
    "*  The `compare()` method should be used in your `heapify` and `heappush` methods to maintain the heap-property for the particular type of heap.  The function should compare two node values and return `True` if the comparison *VIOLATES* the heap-property for your particular heap.\n",
    "\n",
    "```python\n",
    "from math import floor\n",
    "from typing import List\n",
    "\n",
    "class Heap:\n",
    "    def __init__(self, array: List[int]) -> None:\n",
    "        self.elements = array\n",
    "        self.size = len(array) # Number of elements in heap\n",
    "        self.build_heap()\n",
    "\n",
    "    # index of left child of the node at idx\n",
    "    def left(self, idx: int) -> int:\n",
    "        return 2 * idx + 1\n",
    "\n",
    "    # index of right child of the node at idx\n",
    "    def right(self, idx: int) -> int:\n",
    "        return 2 * idx + 2\n",
    "\n",
    "    def parent(self, idx: int) -> int:\n",
    "        return floor((idx - 1) / 2)\n",
    "\n",
    "    def swap(self, idx1: int, idx2: int) -> None:\n",
    "        tmp = self.elements[idx1]\n",
    "        self.elements[idx1] = self.elements[idx2]\n",
    "        self.elements[idx2] = tmp\n",
    "\n",
    "    def to_string(self, prefix: str = \"\", idx: int = 0, left: bool = False) -> str:\n",
    "        if self.size == 0:\n",
    "            return '\\\\--'\n",
    "        elif idx < self.size:\n",
    "            buf = prefix\n",
    "            if left:\n",
    "                buf = buf + \"|-- \"\n",
    "            else:\n",
    "                buf = buf + \"\\\\-- \"\n",
    "            buf = buf + '\\033[1m' + str(self.elements[idx]) + '\\033[0m' + '\\n'\n",
    "            #buf = buf + str(self.elements[idx]) + '\\n' #use if above doesn't work\n",
    "            \n",
    "            new_prefix = prefix\n",
    "            if left:\n",
    "                new_prefix = new_prefix + \"|   \"\n",
    "            else:\n",
    "                new_prefix = new_prefix + \"    \"\n",
    "\n",
    "            return buf + \\\n",
    "                    self.to_string(new_prefix, self.left(idx), True) + \\\n",
    "                    self.to_string(new_prefix, self.right(idx), False)\n",
    "        else:\n",
    "            return ''\n",
    "\n",
    "    def __str__(self) -> str:\n",
    "        return self.to_string()\n",
    "\n",
    "    def __len__(self) -> int:\n",
    "        return self.size\n",
    "\n",
    "    # TODO: override this in your dervied classes\n",
    "    def compare(self, a: int, b: int) -> bool:\n",
    "        raise NotImplementedError\n",
    "\n",
    "    def heapify(self, idx: int) -> None:\n",
    "        # TODO: your solution from the previous question can go here\n",
    "        #       but remember to use your new \"self.compare(a, b)\" instead\n",
    "        #       of raw comparisons\n",
    "        pass\n",
    "\n",
    "    def build_heap(self) -> None:\n",
    "        # TODO: your solution from the previous question can go here\n",
    "        pass\n",
    "\n",
    "    def heappush(self, key: int) -> None:\n",
    "        # TODO: your solution from the previous question can go here\n",
    "        #       but remember to use your new \"self.compare(a, b)\" instead\n",
    "        #       of raw comparisons\n",
    "        pass\n",
    "\n",
    "    def heappop(self) -> int:\n",
    "        # TODO: your solution from the previous question can go here\n",
    "        pass\n",
    "\n",
    "class MinHeap(Heap):\n",
    "    # TODO: complete implementation\n",
    "    pass\n",
    "\n",
    "class MaxHeap(Heap):\n",
    "    # TODO: complete implementation\n",
    "    pass\n",
    "```\n",
    "\n",
    "### Demo: max- and min-heap classes\n",
    "\n",
    "```python\n",
    "mn = MinHeap([1,2,3,4,5])\n",
    "mx = MaxHeap([1,2,3,4,5])\n",
    "\n",
    "print(mn)\n",
    "print(mx)\n",
    "\n",
    "\\-- 1\n",
    "    |-- 2\n",
    "    |   |-- 4\n",
    "    |   \\-- 5\n",
    "    \\-- 3\n",
    "\n",
    "\\-- 5\n",
    "    |-- 4\n",
    "    |   |-- 1\n",
    "    |   \\-- 2\n",
    "    \\-- 3\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Deliverables\n",
    "- `P2.py`: Should contain the `Heap`, `MinHeap` and `MaxHeap` classes. The `Heap` class should be implemented as a base class as described in [Part 2C](#p2.C)."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='part_3'></a>\n",
    "\n",
    "# Problem 3 [30 pts]: Priority Queue\n",
    "\n",
    "A priority queue is an abstract data type that represents a set of elements where each element has some key associated with it (a *priority*). Dequeueing (i.e., removing) an element from the priority queue will return the element with highest (in a max-priority queue) or lowest (in a min-priority queue) key. Thus removing all elements of the priority queue will leave you with a sorted list. A priority queue gets its name from the fact that elements are inserted or removed with priority over others.\n",
    "\n",
    "Our priority queue should support the following three operations:\n",
    "1. **put**: add an element to the set\n",
    "2. **get**: retrieve and remove the element with the largest key (or smallest depending on the type of priority queue)\n",
    "3. **peek**: this should return the largest element (or smallest depending on the type of priority queue)\n",
    "\n",
    "In our priority queue implementation, the key of an element will be the element itself. In a min-priority queue, an element, X, has a *higher priority* compared to element, Y, if `X < Y`. Examples:\n",
    "* `1 < 3` is `True`, so we assume `1` has higher priority\n",
    "* `'beef pho' < 'chicken pho'` is `True` (Python compares strings with lexicographical order), so we assume `'beef pho'` has higher priority\n",
    "* `(1685, 'pho') < (1862, 'rice')` is `True` (Python compares tuples position by position), so we assume `(1685, 'pho')` has higher priority.\n",
    "\n",
    "**Note:** elements in your queue should all be of the same data type. That is, comparisons between different data types do not need to be handled in your queue implementation.\n",
    "\n",
    "**Note:** in a max-priority queue you would compare elements using `>` to compute higher priority.\n",
    "\n",
    "In this problem you will be asked to implement three different versions of a **min-priority queue**.\n",
    "\n",
    "**Copy below code template into a file called `P3.py`.**\n",
    "\n",
    "```python\n",
    "from random import sample\n",
    "from time import time\n",
    "\n",
    "class PriorityQueue:\n",
    "    def __init__(self, max_size):\n",
    "        self.elements = []\n",
    "        self.max_size = max_size\n",
    "        \n",
    "    def __len__(self):\n",
    "        return len(self.elements)\n",
    "    \n",
    "    def __bool__(self):\n",
    "        return len(self.elements) > 0\n",
    "        \n",
    "    def put(self, val):\n",
    "        raise NotImplementedError # TODO\n",
    "    \n",
    "    def get(self):\n",
    "        raise NotImplementedError # TODO\n",
    "    \n",
    "    def peek(self):\n",
    "        raise NotImplementedError # TODO\n",
    "\n",
    "def mergesortedlists(lists, pqclass=PriorityQueue):\n",
    "    merged = []\n",
    "    pq = pqclass(len(lists))\n",
    "    for i, l in enumerate(lists): \n",
    "        pq.put((l.pop(0), i))\n",
    "    \n",
    "    while pq:\n",
    "        ele, i = pq.get()\n",
    "        merged.append(ele)\n",
    "        if lists[i]:\n",
    "            pq.put((lists[i].pop(0), i)) \n",
    "    \n",
    "    return merged\n",
    "\n",
    "\n",
    "def generatelists(n, length=20, dictionary_path='../data/words.txt'):\n",
    "    with open(dictionary_path, 'r') as f:\n",
    "        words = [w.strip() for w in f.readlines()]\n",
    "    lists = []\n",
    "    for _ in range(n):\n",
    "        lists.append(sorted(sample(words, length)))\n",
    "    return lists\n",
    "\n",
    "\n",
    "def timeit(ns=(10, 20, 50, 100, 200, 500), pqclass=PriorityQueue, n_average=5):\n",
    "    elapsed = []\n",
    "    for n in ns:\n",
    "        timeaccum = 0\n",
    "        for _ in range(n_average):\n",
    "            lists = generatelists(n)\n",
    "            start = time()\n",
    "            merged = mergesortedlists(lists, pqclass)\n",
    "            end   = time()\n",
    "            timeaccum += end-start\n",
    "        elapsed.append(timeaccum / n_average)\n",
    "    return elapsed\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p3.a'></a>\n",
    "### Part A [10 points]: NaivePriorityQueue\n",
    "\n",
    "A naive way to implement a priority queue is to use a plain old list. Inserting an element appends to the list and extracting an element scans the whole list before returning (and removing) the highest priority element (remember what *highest priority* means in our min-priority queue).\n",
    "\n",
    "**Your task**: implement a **min-priority queue** class called `NaivePriorityQueue`\n",
    "\n",
    "Put all your code in a file called **P3.py**\n",
    "\n",
    "Your class `NaivePriorityQueue` should inherit the **base class** `PriorityQueue`.\n",
    "\n",
    "`PriorityQueue` will be initialized with a `max_size` which indicates the capacity (maximum number of elements allowed) of the priority queue.\n",
    "\n",
    "Your `NaivePriorityQueue` class needs to implement the methods:\n",
    "1. `put` should take in a value `val` and insert it at the end of the `elements` list. This method should raise an error if called after `max_size` is reached. Nothing should be returned.\n",
    "2. `get` should remove the smallest value from `elements` and return it.\n",
    "2. `peek` should return the smallest value in the queue.\n",
    "\n",
    "**Raise an `IndexError` in the following three cases:**\n",
    "- `put` called on a full priority queue\n",
    "- `get` called on an empty priority queue\n",
    "- `peek` called on an empty priority queue"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Demo\n",
    "\n",
    "```python\n",
    "q = NaivePriorityQueue(2)\n",
    "q.put(1)\n",
    "q.put(2)\n",
    "print(q.peek())\n",
    "\n",
    "1\n",
    "\n",
    "print(q.get())\n",
    "1\n",
    "print(q.get())\n",
    "2\n",
    "```\n",
    "\n",
    "**What should this final statement return?**\n",
    "```python\n",
    "print(q.get())\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p3.b'></a>\n",
    "### Part B [10 points]: Heap-backed priority queue\n",
    "\n",
    "A better way to implement a priority queue is to use a binary heap.\n",
    "\n",
    "**Your task**: Implement a **min-priority** queue using a min-heap. You will implement **two versions**: (1) using your own heap from [question 2](#part_2) (2) using the [heap](https://docs.python.org/3/library/heapq.html) from Python's standard library\n",
    "\n",
    "With the `heappush` and `heappop` methods from the `Heap` class, we can effectively treat a Python list as a heap. If we are using a heap to implement a priority queue: \n",
    "- `put` should push the element to the heap (`heappush`)\n",
    "- `get` should remove and return the root element of the heap (`heappop`)\n",
    "- `peek` should return the smallest element of your min-heap\n",
    "    - your implementation should be flexible enough to be able to return the largest element if we replace the min-heap with a max-heap\n",
    "\n",
    "Please implement two priority queues called `HeapPriorityQueue` and `PythonHeapPriorityQueue` that use your own heap implementation and Python's built-in heap, respectively. As in [Part A](#p3.a) please use `PriorityQueue` as your base class in the same file **P3.py**.\n",
    "\n",
    "**Explicitly raise `IndexError`s as you did in the previous problem where necessary.**"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<a id='p3.c'></a>\n",
    "### Part C [10 points]: Compare Performance of Your Priority Queues\n",
    "\n",
    "Do this problem in a separate Python file called: **P3-C.py**.\n",
    "\n",
    "In this problem, we will motivate the use of a priority queue and make you investigate the impact of the underlying implementation choice.\n",
    "\n",
    "Suppose we want to merge multiple sorted lists into one large sorted list. One way to do it is to maintain a priority queue which holds the head element in each list. We then constantly pop from this queue (to append to the target list) and insert the next element of the corresponding list into the queue. The target list will be sorted because we are always first appending the smallest head element of all lists (given that the lists are sorted, this is the smallest element not merged).\n",
    "\n",
    "We will use the problem of merging lists using priority queues as our benchmark to compare your three priority queue implementations from the previous problems.\n",
    "\n",
    "**Your task**: compare the performance of `NaivePriorityQueue`, `HeapPriorityQueue` and `PythonHeapPriorityQueue` by timing the `mergedsortedlists` method using the `timeit` method (both of which were provided in the `PriorityQueue` skeleton)\n",
    "\n",
    "The `mergesortedlists` function takes a priority queue **class** as an argument (`pqclass`), and performs the merging using that priority queue implementation. Here we test the performance of `mergesortedlists` with lists that contain sorted words from the `words.txt` file provided.  In your final solution, `words.txt` can be at the same directory level as your solution file.\n",
    "\n",
    "The `timeit` function takes a priority queue **class** as an argument (`pqclass`) and measures the running time of `mergesortedlists` for that priority queue. Another argument for `timeit` is `ns`, which is an ascending sequence of the numbers of lists to merge (**this will be the x-axis for your performance plot described below**).\n",
    "\n",
    "Make a line plot to compare the running time of `mergesortedlists` with `NaivePriorityQueue`, `HeapPriorityQueue` and `PythonHeapPriorityQueue` for an increasing number of lists. In the plot, you should have three curves: one for each queue implementation. You should plot the elapsed time against number of lists (the sequence argument, `ns`, passed to `timeit`); we recommend using the default parameters provided in the functions (other than the location for your `words.txt` file, as mentioned above).\n",
    "\n",
    "**Graph format:**\n",
    "- Don't use logarithmic scales\n",
    "- Label your x- and y-axes\n",
    "- Create a descriptive title\n",
    "- x-axis: Number of Lists Merged (ranges from 0 to 500; see `timeit`'s `ns` parameter)\n",
    "- y-axis: Elapsed time in seconds\n",
    "\n",
    "Save the plot as `P3-C.png`.\n",
    "\n",
    "**Note:** `generatelists` reads words from `words.txt`. You should have that in your HW6-final folder."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Deliverables\n",
    "- `P3.py`: should contain `NaivePriorityQueue`, `HeapPriorityQueue` and `PythonHeapPriorityQueue`\n",
    "- `P3-C.py`: should contain the code for [Part C](#p3.c)\n",
    "- `P3-C.png`: should contain a plot comparing the three priority queue runtimes"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.5"
  },
  "toc": {
   "base_numbering": 1,
   "nav_menu": {},
   "number_sections": true,
   "sideBar": true,
   "skip_h1_title": false,
   "title_cell": "Table of Contents",
   "title_sidebar": "Contents",
   "toc_cell": false,
   "toc_position": {},
   "toc_section_display": true,
   "toc_window_display": false
  },
  "varInspector": {
   "cols": {
    "lenName": 16,
    "lenType": 16,
    "lenVar": 40
   },
   "kernels_config": {
    "python": {
     "delete_cmd_postfix": "",
     "delete_cmd_prefix": "del ",
     "library": "var_list.py",
     "varRefreshCmd": "print(var_dic_list())"
    },
    "r": {
     "delete_cmd_postfix": ") ",
     "delete_cmd_prefix": "rm(",
     "library": "var_list.r",
     "varRefreshCmd": "cat(var_dic_list()) "
    }
   },
   "types_to_exclude": [
    "module",
    "function",
    "builtin_function_or_method",
    "instance",
    "_Feature"
   ],
   "window_display": false
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
